﻿Imports Infragistics.Web.UI.GridControls

Partial Class _Default
    Inherits System.Web.UI.Page

#Region "Page"

    Protected Overrides Sub OnInit(e As EventArgs)
        MyBase.OnInit(e)
        Me.whdg1.DataSource = GetPeople()
    End Sub

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load

    End Sub
#End Region

#Region "Grid Events"
    Protected Sub whdg1_InitializeRow(sender As Object, e As Infragistics.Web.UI.GridControls.RowEventArgs) Handles whdg1.InitializeRow
        If isChild = False Then
            DirectCast(e.Row, ContainerGridRecord).IsEmptyParent = True
        End If

    End Sub


    Protected Sub whdg1_RowIslandsPopulating(sender As Object, e As Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs) Handles whdg1.RowIslandsPopulating
        e.Cancel = True
        Dim child As New ContainerGrid()
        AddHandler child.InitializeRow, AddressOf child_InitializeRow

        e.Row.RowIslands.Add(child)

        child.DataSource = GetAddresses()
        child.DataBind()
    End Sub

#End Region

#Region "Child grid events"


    Private isChild As Boolean = False
    Private Sub child_InitializeRow(sender As Object, e As RowEventArgs)
        e.Row.Items(0).Column.Header.Text = "This is the changed Add"
        isChild = True
    End Sub
#End Region

#Region "Entities"

    Public Class Person
        Public _addressID As Integer
        Public Property ID() As Integer
            Get
                Return m_ID
            End Get
            Set(value As Integer)
                m_ID = Value
            End Set
        End Property
        Private m_ID As Integer
        Public Property Fname() As String
            Get
                Return m_Fname
            End Get
            Set(value As String)
                m_Fname = Value
            End Set
        End Property
        Private m_Fname As String
        Public Property Sname() As String
            Get
                Return m_Sname
            End Get
            Set(value As String)
                m_Sname = Value
            End Set
        End Property
        Private m_Sname As String
        Public ReadOnly Property Addresses() As Integer
            Get
                Return _addressID
            End Get
        End Property
    End Class
    Public Class Address
        Public Property ID() As Integer
            Get
                Return m_ID
            End Get
            Set(value As Integer)
                m_ID = Value
            End Set
        End Property
        Private m_ID As Integer
        Public Property Street() As String
            Get
                Return m_Street
            End Get
            Set(value As String)
                m_Street = Value
            End Set
        End Property
        Private m_Street As String
        Public Property City() As String
            Get
                Return m_City
            End Get
            Set(value As String)
                m_City = Value
            End Set
        End Property
        Private m_City As String

    End Class

#End Region

#Region "Data"

    Private Function GetPeople() As List(Of Person)
        Dim list As New List(Of Person)()
        list.Add(New Person() With { _
         .ID = 1, _
         .Fname = "Rado", _
         .Sname = "Minchev", _
         ._addressID = 1 _
        })
        list.Add(New Person() With { _
         .ID = 2, _
         .Fname = "Vlado", _
         .Sname = "Zagorski", _
         ._addressID = 1 _
        })
        list.Add(New Person() With { _
         .ID = 3, _
         .Fname = "Alex", _
         .Sname = "Fidanov", _
         ._addressID = 1 _
        })
        list.Add(New Person() With { _
         .ID = 4, _
         .Fname = "Ivan", _
         .Sname = "Simeonov", _
         ._addressID = 2 _
        })
        list.Add(New Person() With { _
         .ID = 5, _
         .Fname = "Anton", _
         .Sname = "Staikov", _
         ._addressID = 2 _
        })
        list.Add(New Person() With { _
         .ID = 6, _
         .Fname = "Dimi", _
         .Sname = "Gineva", _
         ._addressID = 2 _
        })
        list.Add(New Person() With { _
         .ID = 7, _
         .Fname = "Danko", _
         .Sname = "Valkov", _
         ._addressID = 2 _
        })
        list.Add(New Person() With { _
         .ID = 8, _
         .Fname = "Cveti", _
         .Sname = "Georgieva", _
         ._addressID = 2 _
        })
        Return list
    End Function


    Private Function GetAddresses() As List(Of Address)
        Dim list As New List(Of Address)()
        list.Add(New Address() With { _
         .ID = 1, _
         .City = "Windsor", _
         .Street = "Corporate Park 50 Millstone Road" _
        })
        list.Add(New Address() With { _
         .ID = 2, _
         .City = "Sofia", _
         .Street = "110 B, Simeonovsko Shosse  Office Floor II" _
        })
        Return list
    End Function

#End Region

End Class
